#include <bits/stdc++.h>

using namespace std;

int n,m;
int k;
int vis[1005][1005];
int por[] = {1,-1,0,0};
int pok[] = {0,0,-1,1};
int mat[1005][1005];

void bfs(int sr,int sk)
{
    queue<pair<int,int>> q;
    q.push({sr,sk});
    vis[sr][sk] = 1;
    
    while(!q.empty())
    {
        pair<int,int> p = q.front();
        int rr = p.first;
        int kk = p.second;
        q.pop();
        for(int i=0;i<4;i++)
        {
            int nr = rr + por[i];
            int nk = kk + pok[i];
            if(nr>=1 && nr<=n && nk>=1 && nk<=m && mat[nr][nk]==1 && vis[nr][nk]==0)
            {
                vis[nr][nk] = 1;
                q.push({nr,nk});
            }
        }
    }
}

int main() 
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    
    cin >> n >> m >> k;
    
    if(n<=1000 && m<=1000)
    {
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
            {
                mat[i][j] = 1;
                vis[i][j] = 0;
            }
        }
        for(int i=1;i<=k;i++)
        {
            int x,y;
            cin >> x >> y;
            mat[x][y] = 0;
        }
        
        int cnt = 0;
        
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
            {
                if(mat[i][j]==1 && vis[i][j]==0)
                {
                    bfs(i,j);
                    cnt++;
                }
            }
        }
        
        cout << cnt;
    }
    
    return 0;
}